"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const migration_1 = require("./migration");
const success = (response) => ({
    statusCode: 200,
    body: JSON.stringify(response),
});
const getEngine = () => {
    if (!process.env.SLS_TYPEORM_MIGRATIONS_ENGINE) {
        process.exit(1);
    }
    return process.env.SLS_TYPEORM_MIGRATIONS_ENGINE;
};
const getMigrationFolder = () => {
    if (!process.env.SLS_TYPEORM_MIGRATIONS_FOLDER) {
        process.exit(1);
    }
    return process.env.SLS_TYPEORM_MIGRATIONS_FOLDER;
};
const handler = (handlerName) => (event, context, callback) => __awaiter(void 0, void 0, void 0, function* () {
    context.callbackWaitsForEmptyEventLoop = false;
    const migration = new migration_1.default({
        type: getEngine(),
        url: process.env.SLS_TYPEORM_MIGRATIONS_DATABASE_URL,
        migrations: [getMigrationFolder()],
    });
    try {
        const response = yield migration[handlerName]();
        callback(null, success(response));
    }
    catch (error) {
        callback(error);
    }
});
exports.up = handler("runMigration");
exports.down = handler("undoLastMigration");
