"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const typeorm_1 = require("typeorm");
class Migration {
    constructor(config) {
        this.config = config;
        this.connection = null;
    }
    init() {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                this.connection = yield typeorm_1.createConnection(this.config);
            }
            catch (error) {
                throw error;
            }
        });
    }
    runMigration() {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function* () {
            try {
                yield this.init();
                const result = yield ((_a = this.connection) === null || _a === void 0 ? void 0 : _a.runMigrations({
                    transaction: "none",
                }));
                yield ((_b = this.connection) === null || _b === void 0 ? void 0 : _b.close());
                return result;
            }
            catch (error) {
                throw error;
            }
        });
    }
    undoLastMigration() {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function* () {
            try {
                yield this.init();
                yield ((_a = this.connection) === null || _a === void 0 ? void 0 : _a.undoLastMigration({
                    transaction: "none",
                }));
                yield ((_b = this.connection) === null || _b === void 0 ? void 0 : _b.close());
            }
            catch (error) {
                throw error;
            }
        });
    }
}
exports.default = Migration;
